// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#pragma once

#include <list>

class EnemyGuard
{
public:
	EnemyGuard();
	EnemyGuard( const Vector2& origin, const float forwardDeg );
	~EnemyGuard();

	void MoveForward( const float dist );
	void Turn( const float deg );
	void PathMove();
	void FindClosestPathXYForCurrentDirection( int posX, int posY, int& closestX, int& closestY, Vector2& vectorToGoal );
	void FindClosestPathXYForCurrentDirection2( int posX, int posY, int& closestX, int& closestY, Vector2& vectorToGoal );
	void LerpVisionDeg();
	void Render( const bool highlight = false );
	void Think();

	Vector2		m_origin;
	float		m_forwardDeg;
	Vector2		m_forward;
	float		m_visionDeg;
//	Vector2		m_vision;
	float		m_fov;
	float		m_visionDist;
	bool		m_canSeePlayer;
	int			m_goalGridX;
	int			m_goalGridY;

	static std::list< EnemyGuard* > m_guardList;
};

