// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#pragma once
#include "MapData.h"
#include "gameCommon.h"


//-------------------------------------------------------------------------------------------------
// PathFinding class
// 
// Mostly just a collection of pathfinding logic functions
//-------------------------------------------------------------------------------------------------
class PathFinding
{
public:

	bool IsXYOnEnemyPath( int x, int y );
	void FindClosestPathLocation( int& closestPathX, int& closestPathY, const Vector2& referencePosition );
};


//-------------------------------------------------------------------------------------------------
// global data
//-------------------------------------------------------------------------------------------------
extern PathFinding g_pathFinding;
extern const float g_semiCardinalCos[ 8 ];
extern const float g_semiCardinalSin[ 8 ];
extern const int g_semiCardinalX[ 8 ];
extern const int g_semiCardinalY[ 8 ];
extern const float g_quarterCardinalCos[ 16 ];
extern const float g_quarterCardinalSin[ 16 ];
extern const int g_quarterCardinalX[ 16 ];
extern const int g_quarterCardinalY[ 16 ];


