// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#pragma once




//-------------------------------------------------------------------------------------------------
// Player class
//-------------------------------------------------------------------------------------------------
struct Player
{
	Vector2		m_origin;
	float		m_forwardDeg;
	Vector2		m_forward;
	float		m_fov;
	float		m_visionDist;

	bool		m_movingRight;
	bool		m_movingUp;
	bool		m_movingLeft;
	bool		m_movingDown;

	float		m_bustaculation;  // 0 = nobody can see, 1 = busted


	Player();
	void Draw();
	void Move();
	void UpdateBustaculation();
	bool DoesMovementCauseCollision( Vector2& start, Vector2& end );
	void LocatePlayerStartPosition();
	void OnKeyAction( const byte_t key, bool isKeyDown );
};




//-------------------------------------------------------------------------------------------------
// global data
//-------------------------------------------------------------------------------------------------
extern Player* g_player;


