//-------------------------------------------------------------------------------------------------
// TheGame.h (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_TheGame_
#define _include_TheGame_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
//#include "pch.h"
#include "gameCommon.h"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		TheGame
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class TheGame
{
private:
public:
	/// Constructors / destructors
	TheGame(); // default constructor
	~TheGame(); // destructor

	/// Public methods
	void PreInit();
	void PostInit();
	void RunFrame();

	void DoRealTimeAlterations();
	void UpdateEverything();
	void DrawEverything();

	void SpawnEnemies();
	void UpdateEnemies();
	
	static bool IsPointInViewCone( const Vector2& viewerOrigin, const Vector2& testOrigin, const float forwardDeg, const float fovDeg, const float viewDist );

	void OnKeyDown( const byte_t key );
	void OnKeyUp( const byte_t key );
};


//-------------------------------------------------------------------------------------------------
// Externally viewable globals
//-------------------------------------------------------------------------------------------------
extern TheGame* g_game;


#endif // _include_TheGame_
